--==================================================================================
--Copyright (c) 2018-2019 Hulua Group. All rights reserved.
--==================================================================================
local InstanceCall = define "InstanceCall"

function InstanceCall:Initialize(first_call, last_call)
	self.ref_count = 0
	CHECK(type(first_call) == "function", "Must be a functions")
	CHECK(type(last_call) == "function", "Must be a functions")
	self.first_call = first_call
	self.last_call = last_call
end

function InstanceCall:Retain()
	self.ref_count = self.ref_count + 1
	CHECK(self.ref_count >= 0, "Invalid ref_count: ", self.ref_count)
	if self.ref_count == 1 then
		self.first_call()
	end
end

function InstanceCall:Release(force_release)
	self.ref_count = self.ref_count - 1
	CHECK(self.ref_count >= 0, "Invalid ref_count: ", self.ref_count)
	if self.ref_count == 0 then
		self.last_call()
	end
end

function InstanceCall:GetRefCount()
	return self.ref_count
end

return InstanceCall